unit DataTypes;

interface

uses Windows;

const
  VID = $04B4;
  PID = $0328;  // For CCD Camera

  FOREVER_TARGET_FRAMES = $8888;

  MAX_CAMERA_WORK_SET  = 8;
  MAX_EXPOSURE_TIME = 3;
  MAX_EXPOSURETIME : Array[0..MAX_EXPOSURE_TIME] of integer = ( 10, 100, 1000, 6500 );

type
  eDEVICETYPE = ( TCD1304 );
  eWORKMODE = ( CONTINUE_MODE , EXT_TRIGGER_MODE );
  //eEXTTRIGGERSTAT = ( EXT_SUCCESS, EXT_INPROCESS, EXT_ABORT );

  DWord = LongInt;
  PByte = ^Byte;
  PWord = ^Word;
  PDword = ^DWord;
  PLong = ^Integer;
  PInteger = ^Integer;

  TCCDCamera = record
    DeviceType : eDEVICETYPE;
    FWVersion  : integer;
    APVersion  : integer;
    BLVersion  : integer;
  end;

  TCameraControl = record
    ExposureTime : integer;
    CurrentMode  : eWORKMODE;
    GrabFrameCount : integer;
    GrabFrameDirectory : String;
    GrabFrameFile : String;
  end;

  TParameterSetCtl = record
    HaveCommand : Boolean;
    CommandValue: integer;
    Tag : integer;
    Command : ( SET_EXPOSURE, SET_GPIOCONFIG, SET_GPIOSET );
  end;

  TGrabFrameToFileCtl = record
    SavetoFileNeeded: Boolean;
    SaveFileCount : integer;
    SavedCount: integer;
  end;

var
  OneInstaceMutex : THandle;
  ContinueRun : Boolean;
  CurrentDevices : integer;
  CurrentSelectedDevices : integer;
  SelectedDevice : integer;
  ParaSetCtl : TParameterSetCtl;
  SaveFileCtl: TGrabFrameToFileCtl;
  
  CameraModuleNo: Array[1..MAX_CAMERA_WORK_SET] of String;
  CameraSerialNo: Array[1..MAX_CAMERA_WORK_SET] of String;
  CameraParaControl : Array[1..MAX_CAMERA_WORK_SET] of TCameraControl;
  CameraSelected : Array[1..MAX_CAMERA_WORK_SET] of Boolean;
  SelectableDevices : Array[0..MAX_CAMERA_WORK_SET-1] of integer;
  
implementation

end.
