unit DllInterface;

interface

uses windows, graphics, DataTypes;

type

  PProcessedDataProperty = ^TProcessedDataProperty;
  TProcessedDataProperty = record
    CameraID : integer;
    ExposureTime : integer;
    TimeStamp : integer;
    TriggerOccurred : integer;    
    TriggerEventCount: integer;
    OverSaturated: integer;
    LightShieldAverageValue : integer;    
  end;

TGetFrameCallBack = procedure( FrameType: integer; Row : integer; Col : integer;
                               ImageProperty : PProcessedDataProperty ; FramePtr : PByte ); cdecl;
  
TUSBDeviceCallBack = procedure( DeviceType: integer ); cdecl;

// General functions
function CCDUSBInitDevice() : integer; cdecl;
function CCDUSBUnInitDevice() : integer; cdecl;
function CCDUSBGetModuleNoSerialNo( DeviceID : integer; ModuleNo : PAnsiChar; SerialNo : PAnsiChar ): integer; cdecl;
function CCDUSBAddDeviceToWorkingSet( deviceID : integer ) : integer; cdecl;
function CCDUSBRemoveDeviceFromWorkingSet( deviceID : integer ) : integer; cdecl;
function CCDUSBStartCameraEngine( ParentFormHandle : THandle ) : integer ; cdecl;
function CCDUSBStopCameraEngine() : integer ; cdecl;
function CCDUSBSetCameraWorkMode( DeviceID : integer ;
                                   WorkMode : Integer ) : integer; cdecl;
function CCDUSBStartFrameGrab( TotalFrames : Integer ) : integer ; cdecl;
function CCDUSBStopFrameGrab( ) : integer ; cdecl;
function CCDUSBShowFactoryControlPanel( deviceID : integer ; passWord: PChar ) : integer; cdecl;
function CCDUSBHideFactoryControlPanel() : integer; cdecl;
//function CCDUSBSetResolution( deviceID : integer ; SettingPtr : PImageControl ):integer; cdecl;
function CCDUSBSetExposureTime( deviceID : integer ;
                                exposureTime : integer; Store : Boolean ) : integer; cdecl;
function CCDUSBInstallFrameHooker( FrameType : integer ; FrameHooker : TGetFrameCallBack  ) : integer; cdecl;
function CCDUSBInstallUSBDeviceHooker( USBDeviceHooker : TUSBDeviceCallBack ) : integer; cdecl;
function CCDUSBGetCurrentFrame( deviceID : integer ; var FramePtr : PWord ) : PWord ;cdecl;
function CCDUSBSetGPIOConifg( deviceID : integer ; ConfigByte : Byte ) : integer; cdecl;
function CCDUSBSetGPIOInOut( deviceID : integer ; OutputByte : Byte;
                              InputBytePtr : PByte ) : integer; cdecl;


implementation

function CCDUSBInitDevice; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_InitDevice';
function CCDUSBUnInitDevice; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_UnInitDevice';
function CCDUSBGetModuleNoSerialNo; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_GetModuleNoSerialNo';
function CCDUSBAddDeviceToWorkingSet; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_AddDeviceToWorkingSet';
function CCDUSBRemoveDeviceFromWorkingSet; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_RemoveDeviceFromWorkingSet';
function CCDUSBStartCameraEngine; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_StartCameraEngine';
function CCDUSBStopCameraEngine; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_StopCameraEngine';
function CCDUSBSetCameraWorkMode; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_SetCameraWorkMode';
function CCDUSBStartFrameGrab; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_StartFrameGrab';
function CCDUSBStopFrameGrab; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_StopFrameGrab';
function CCDUSBShowFactoryControlPanel; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_ShowFactoryControlPanel';
function CCDUSBHideFactoryControlPanel; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_HideFactoryControlPanel';
//function CCDUSBGetFrameSetting; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_GetFrameSetting';
//function CCDUSBSetFrameSetting; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_SetFrameSetting';
//function CCDUSBSetResolution; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_SetResolution';
function CCDUSBSetExposureTime; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_SetExposureTime';
function CCDUSBInstallFrameHooker; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_InstallFrameHooker';
function CCDUSBInstallUSBDeviceHooker; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_InstallUSBDeviceHooker';
function CCDUSBGetCurrentFrame; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_GetCurrentFrame';
function CCDUSBSetGPIOConifg; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_SetGPIOConifg';
function CCDUSBSetGPIOInOut; external 'CCD_USBCamera_SDK.dll' name 'CCDUSB_SetGPIOInOut';


end.

